/*------------------------------------------------------*\
 * Parallel Resistance Calculator Program		*
 * G. Forrest Cook W0RIO 1/12/2024 www.solorb.com	*
 * License: GPL Version 3				*
\*------------------------------------------------------*/

# include <stdio.h>
# include <math.h>
# define TRUE 1
# define FALSE 0

/*
 * Function declarations below
 */

int get_g_num ();
void set_rknown ();
void set_rdesired ();
void rcalculate ();
int print_menu1 ();

/*
 * Global vars below.
 */

float Rk, Rd, Rp;
int rv = FALSE, type = 1;

int main ()
{
	int sel;

	do
	{
		sel = print_menu1 ();	/* display the menu */

		switch (sel)
		{
		case 1:
			set_rknown ();
		break;
		case 2:
			set_rdesired ();
		break;
		}
	}
	while (sel > 0);

	return (-1);
}

/*--------------------------------------------------------------*/

int print_menu1 ()
{
    printf ("\nParallel Resistance Calculator\n");
    printf ("\n0 -- Quit");
    printf ("\n1 -- Set Known Resistance");
    printf ("\n2 -- Set Desired Resistance and Calculate Parallel Resistor");
    printf ("\n\nSelection: ");
    return (get_g_num (0, 2, 1, 10));
}

/*--------------------------------------------------------------*/

void set_rknown ()
{
    do
    {
	printf ("\nEnter The known Resistor value (ohms): ");
	scanf ("%f", &Rk);
	getchar();	/* get last cr */
	if (Rk < 0.0)
	    printf ("\nNegative known resistance value, out of range.\n");
    } while (Rk < 0.0);
}

/*--------------------------------------------------------------*/

void set_rdesired ()
{
    do
    {
	printf ("\nEnter The desired final Resistor value (ohms): ");
	scanf ("%f", &Rd);
	getchar();	/* get last cr */
	if (Rd < 0.0)
	    printf ("Error: Negative known resistance value, out of range.");
	else if (Rd >= Rk)
	    printf ("Error: final value must be less than %5.2f ohms.", Rk);
    } while ((Rd < 0.0) || (Rd >= Rk));

    rcalculate ();
}

/*--------------------------------------------------------------*/

void rcalculate ()
{
    Rp = 1.0 / (1.0 / Rd - 1.0 / Rk);

    printf ("\nResults:\n");
    printf ("\n  0------+-------+");
    printf ("\n         |     P |");
    printf ("\n         |     A |");
    printf ("\n  T    K /     R /");
    printf ("\n  O    N \\     A \\");
    printf ("\n  T    O /     L /");
    printf ("\n  A    W \\     E \\");
    printf ("\n  L    N /     L /");
    printf ("\n         |     L |");
    printf ("\n         |       |");
    printf ("\n  0------+-------+");
    printf ("\n\nParallel %5.2f ohms across %5.2f ohms to get %5.2f ohms.\n",
		Rp, Rk, Rd);
}

/*--------------------------------------------------------------*/
